<template>

    <div class="col-sm-8 offset-sm-2 ">
        <form @submit.prevent="add">
            <div class="form-group">
                <label for="postTitle">Title</label>
                <input type="text" v-model="post.title" class="form-control" id="postTitle" placeholder="Enter title">
            </div>
            <div class="form-group">
                <label for="teaser">Teaser</label>
                <wysiwyg v-model="post.teaser" id="teaser"></wysiwyg>
            </div>
            <div class="form-group">
                <label for="bodyTextarea">Body</label>
                <wysiwyg v-model="post.content" id="bodyTextarea"></wysiwyg>
            </div>

            <div class="form-group">
                <label for="dropzone">Images</label>
                <vue-dropzone
                    ref="myVueDropzone"
                    id="dropzone"
                    :options="dropzoneOptions"
                    @vdropzone-error="getErrorMessage"
                    @vdropzone-sending="sendingEvent"
                    @vdropzone-success="uploadSuccess">
                </vue-dropzone>
            </div>

            <div class="form-group text-right">
                <router-link to="/" class="btn">Cancel</router-link>
                <button type="submit" class="btn btn-primary">
                    Create
                </button>
            </div>
        </form>
        <div class="errors" v-if="errors">
            <ul>
                <li v-for="(fieldsError, fieldName) in errors" :key="fieldName">
                    <strong>{{ fieldName }}</strong> {{ fieldsError.join('\n') }}
                </li>
            </ul>
        </div>
    </div>
</template>


<script>
    import validate from 'validate.js';
    import vue2Dropzone from 'vue2-dropzone'
    import 'vue2-dropzone/dist/vue2Dropzone.min.css'

    export default {
        name: 'new',
        components: {
            vueDropzone: vue2Dropzone,
        },
        data() {
            return {
                jwt: '',
                post: {
                    title: '',
                    teaser: '',
                    content: '',
                    image: []
                },
                dropzoneOptions: {
                    url: '/api/v1/formSubmit',
                    maxFilesize: 5,
                    maxFiles: 4,
                    thumbnailWidth: 150,
                    thumbnailHeight: 150,
                    addRemoveLinks: true,
                    headers: {'Authorization': 'Bearer ' + localStorage.getItem('token')}
                },
                errors: null
            };
        },
        computed: {
            userData() {

                return this;
            },
        },
        methods: {
            sendingEvent(file, xhr, formData) {
            },
            uploadSuccess(file, response) {
                this.post.image.push(response.data);
            },
            removeImage(file) {
                console.log('Remove logo');
            },
            add() {
                this.errors = null;

                const constraints = this.getConstraints();

                const errors = validate(this.$data.post, constraints);

                if (errors) {
                    this.errors = errors;
                    return;
                }

                this.$store.dispatch('createPost', {post: this.post});
                this.$router.push('/');
            },
            getConstraints() {
                return {
                    title: {
                        presence: true,
                        length: {
                            minimum: 3,
                            message: 'Must be at least 3 characters long'
                        }
                    },
                    teaser: {
                        presence: true,
                        length: {
                            minimum: 50,
                            message: 'Must be at least 50 characters long'
                        }
                    },
                    content: {
                        presence: true,
                        length: {
                            minimum: 150,
                            message: 'Must be at least 50 characters long'
                        }
                    },
                };
            },
            getErrorMessage(file, message, xhr) {

            },
            afterComplete(file) {
                console.log(JSON.parse(file.xhr.response));

            },
        },
        mounted() {
            console.log('Component mounted.')
        }
    }
</script>

